<?php

namespace App\Policies;

use App\Models\BorangUlasanIk;
use App\Models\User;
use Illuminate\Auth\Access\Response;

class BorangUlasanIkPolicy
{
    /**
     * Determine whether the user can view any models.
     */
    public function viewAny(User $user): bool
    {
        //
    }

    /**
     * Determine whether the user can view the model.
     */
    public function view(User $user, BorangUlasanIk $borangUlasanIk): bool
    {
        //
        return UserPolicies::where('user_id', $user)->where('modul', 'penjaja')->exists();
    }

    /**
     * Determine whether the user can create models.
     */
    public function create(User $user): bool
    {
        //
        return UserPolicies::where('user_id', $user)->where('modul', 'penjaja')->where('akses', 'pemeriksaan tapak')->exists();
    }

    /**
     * Determine whether the user can update the model.
     */
    public function update(User $user, BorangUlasanIk $borangUlasanIk): bool
    {
        //
        return (UserPolicies::where('user_id', $user)->where('modul', 'penjaja')->where('akses', 'pemeriksaan tapak')->exists()) && ($user->id === $borangUlasanIk->pegawai_id);
    }

    /**
     * Determine whether the user can delete the model.
     */
    public function delete(User $user, BorangUlasanIk $borangUlasanIk): bool
    {
        //
        return $user->id === $borangUlasanIk->pegawai_id;
    }

    /**
     * Determine whether the user can restore the model.
     */
    public function restore(User $user, BorangUlasanIk $borangUlasanIk): bool
    {
        //
    }

    /**
     * Determine whether the user can permanently delete the model.
     */
    public function forceDelete(User $user, BorangUlasanIk $borangUlasanIk): bool
    {
        //
    }
}
